from mpi4py import MPI
import numpy as np

# Get rank & size
comm = MPI.COMM_WORLD
size = comm.Get_size()
rank = comm.Get_rank()

dimCart2D = [4, 2]

if dimCart2D[0]*dimCart2D[1] != size:
  print("The number of processes is not correct!")
  # Abort the program

# Create a 2D cartesian topology -> commCart2D

# Get the rank and coordinates in the 2D cartesian topology
rank = commCart2D.Get_rank()
coordCart2D = commCart2D.Get_coords(rank)

# Initialize the array v and w
if (coordCart2D[0] == 1) :
  v = np.array([1, 2, 3, 4], dtype=np.float64)
else:
  v = np.zeros(4, dtype=np.float64)
w = np.zeros(1, dtype=np.float64)

# Subdividing the 2D cartesian topology with SPLIT

# Scatter using this new communicator


print(f"Rang : {rank} ; Coordinates ({coordCart2D[0]}, {coordCart2D[1]}) "
      f"; w = {w}")
